/*******************************************************
CodeWizardAVR V3.12 Advanced

Chip type               : ATmega328P
Program type            : Application
AVR Core Clock frequency: 16,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 512
*******************************************************/

#include <mega328p.h>
#include <stdio.h>
#include <delay.h>
// Alphanumeric LCD functions
 #asm
   .equ __lcd_port=0x0b //PORTD
#endasm
#include <alcd.h>
#include "wire_ds.c"

char buff[40];
volatile int t1=0,t2=0;
float tf1=0,tf2=0;


void pr()
{
 #asm ("cli");
// t1 = temp_18b20(0);
//t2 = temp_18b20(2); 
 tf1 = Ftemp_18b20(0);
 tf2 = Ftemp_18b20(2);
 #asm ("sei"); 

   if(t1 > 1000) //  <0
   {
   t1 = 4096 - t1 ;
   t1 = -t1 ;
   }
    if(t2 > 1000) //  <0
   {
   t2 = 4096 - t2 ;
   t2 = -t2 ;
   }

//lcd_gotoxy(1,0); sprintf(buff,"%i.%iC     ",t1/10,t1%10); lcd_puts(buff);
//lcd_gotoxy(1,1); sprintf(buff,"%i.%iC     ",t2/10,t2%10); lcd_puts(buff);
 lcd_gotoxy(1,0); sprintf(buff,"%0.1fC     ",tf1); lcd_puts(buff);
 lcd_gotoxy(1,1); sprintf(buff,"%0.1fC     ",tf2); lcd_puts(buff);
delay_ms(150);
}

void main(void)
{
// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=(1<<CLKPCE);
CLKPR=(0<<CLKPCE) | (0<<CLKPS3) | (0<<CLKPS2) | (0<<CLKPS1) | (0<<CLKPS0);
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRB=(0<<DDB7) | (0<<DDB6) | (0<<DDB5) | (0<<DDB4) | (0<<DDB3) | (0<<DDB2) | (0<<DDB1) | (0<<DDB0);
// State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (1<<PORTB2) | (1<<PORTB1) | (1<<PORTB0);

// Port C initialization
// Function: Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (0<<DDC1) | (0<<DDC0);
// State: Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (1<<PORTC0);

// Port D initialization
// Function: Bit7=Out Bit6=Out Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out 
DDRD=(1<<DDD7) | (1<<DDD6) | (1<<DDD5) | (1<<DDD4) | (1<<DDD3) | (1<<DDD2) | (1<<DDD1) | (1<<DDD0);
// State: Bit7=0 Bit6=0 Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=0 
PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);

// Alphanumeric LCD initialization
// Connections are specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTD Bit 6
// RD - PORTD Bit 5
// EN - PORTD Bit 4
// D4 - PORTD Bit 3
// D5 - PORTD Bit 2
// D6 - PORTD Bit 1
// D7 - PORTD Bit 0
// Characters/line: 16
lcd_init(16);

      ds18b20_pin(0);  //        0
      init_w1_ds(-55,125,DS18B20_12BIT);  // 1       12  
        
      ds18b20_pin(2);  //        2
      init_w1_ds(-55,125,DS18B20_12BIT);  // 1       9 
             
while (1)
      {
        pr();
      }
}
